﻿using System;
using System.CodeDom;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.ListView;


namespace _02_dat_winform
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        /*
         * 
         * Databáze V3.2 MS-SQL LOCALDB, David Tomek I4 25.9.2024 https://home.spsostrov.cz/~tomeda/, unixuser@seznam.cz"
         * */


        //Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename="C:\Users\unixu\Documents\spsostrov-individualni-vzdelavaci-plan-ctvrty-rocnik-i4-od-1.9.2023\pgv\opakovani od 3.9.2024\02-dat-winform\02-dat-winform\Database1.mdf";Integrated Security=True
        //Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename='|DataDirectory|Database1.mdf';Integrated Security=True";
        String connectionString = @"Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename='|DataDirectory|Database1.mdf';Integrated Security=True";

        private void Form1_Load(object sender, EventArgs e)
        {
            saveFileDialog1.Filter = "Csv Files (*.csv)|*.csv";
            openFileDialog1.Filter = "Csv Files (*.csv)|*.csv";
        }

        List<string> dataList = new List<string>();

        private void button1_Click(object sender, EventArgs e)
        {
            //LOAD TABLE FROM DATABASE
            LoadDatabase();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            //BACKUP LOADED TABLE FROM DATABASE TO CSV FILE
            BackupDatabase();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //LOAD BACKUP DATA FROM CSV FILE 
            LoadBackup();
            EraseTable();
            InsertLoadedDataFromCSVFile();
            DeleteLoadedContent();
            LoadDatabase();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //ERASE TABLE FROM DATABASE
            EraseTable();

        }

     

        private void button9_Click(object sender, EventArgs e)
        {
            //INSERT
            //INSERT DATA TO TABLE FROM TEXTBOXES WHERE ID
            InsertDataIntoTable();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            //UPDATE
            //UPDATE DATA IN TABLE FROM TEXTBOXES BY ID
            UpdateDataInTable();

        }


        private void button10_Click(object sender, EventArgs e)
        {
            //DELETE
            //DELETE DATA IN TABLE BY TEXTBOX ID
            DeleteDataInTableByID();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            //About
            MessageBox.Show("Databáze V3.2 MS-SQL LOCALDB, David Tomek I4 25.9.2024 https://home.spsostrov.cz/~tomeda/, unixuser@seznam.cz");
        }

        private void button6_Click(object sender, EventArgs e)
        {   //Close
            Close();
        }


        void LoadDatabase()
        {
            //LOAD TABLE FROM DATABASE
            //listBox1.Items.Clear();
            dataList.Clear();
            //listBox1.Items.Add("ID\tFirstName\tLastName\tAge\tEmai\tAddress\tPhone\tJob");
            //dataList.Add("ID\tFirstName\tLastName\tAge\tEmail\tAddress\tPhone\tJob");
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("Id");
            dataTable.Columns.Add("FirstName");
            dataTable.Columns.Add("LastName");
            dataTable.Columns.Add("Age");
            dataTable.Columns.Add("Email");
            dataTable.Columns.Add("Address");
            dataTable.Columns.Add("Phone");
            dataTable.Columns.Add("Job");

            string dotaz = "SELECT * FROM Osoby";
            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();
            SqlCommand prikaz = new SqlCommand(dotaz, spojeni);
            SqlDataReader dataReader = prikaz.ExecuteReader();
            //string data = "";
            int i = 0;
            string[] vstup = null;
            string radka = null;
            while (dataReader.Read())
            {
                dataList.Add(dataReader[0] + "\t" + dataReader[1] + "\t" + dataReader[2] + "\t" + dataReader[3] + "\t" + dataReader[4] + "\t" + dataReader[5] + "\t" +
                dataReader[6] + "\t" + dataReader[7]);

            }
            
            foreach (string s in dataList)
            {
                vstup = s.Split('\t');
                for (int j = 0; j < vstup.Length; j++)
                {
                    vstup[j] = vstup[j].Trim();
                  
                }
                DataRow row = dataTable.NewRow();
                row["ID"] = vstup[0];
                row["FirstName"] =vstup[1];
                row["LastName"] = vstup[2];
                row["Age"] = vstup[3];
                row["Email"] = vstup[4];
                row["Address"] = vstup[5];
                row["Phone"] = vstup[6];
                row["Job"] = vstup[7];
                dataTable.Rows.Add(row);
                //radka = String.Join("\t", vstup);
                //listBox1.Items.Add(radka);
                //dataTable.Rows.Add(radka);

            }
            
            dataGridView1.DataSource = dataTable;
            spojeni.Close();

        }

        void BackupDatabase()
        {
            //BACKUP LOADED TABLE FROM DATABASE TO CSV FILE
            string[] dataS;
            string dataS2;

            DialogResult vysledek = saveFileDialog1.ShowDialog();
            if (vysledek == DialogResult.OK)
            {
                StreamWriter soubor = new StreamWriter(saveFileDialog1.FileName);
                foreach (string data in dataList)
                {
                    dataS = data.Split('\t');

                    for (int i = 0; i < dataS.Length; i++)
                    {
                        dataS[i] = dataS[i].Trim();
                    }

                    dataS2 = String.Join(";", dataS);
                    soubor.WriteLine(dataS2);
                }
                soubor.Close();
            }

        }

        void LoadBackup()
        {
            //LOAD BACKUP DATA FROM CSV FILE 
            //listBox1.Items.Clear();
            dataList.Clear();
            DialogResult vysledek = openFileDialog1.ShowDialog();
            string radka = null;
            string[] vstup = null;
            string data = null;
            if (vysledek == DialogResult.OK)
            {
                StreamReader soubor = new StreamReader(openFileDialog1.FileName);
                while ((radka = soubor.ReadLine()) != null)
                {
                    vstup = radka.Split(';');
                    data = String.Join("\t", vstup);
                    //listBox1.Items.Add(data);
                    dataList.Add(data);

                }
                soubor.Close();
            }
        }

        void EraseTable()
        {
            //ERASE TABLE FROM DATABASE
            string dotaz = "DELETE  FROM Osoby";
            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();
            SqlCommand prikaz = new SqlCommand(dotaz, spojeni);
            prikaz.ExecuteNonQuery();
            spojeni.Close();
        }

        void InsertLoadedDataFromCSVFile()
        {
            //INSERT LOADED DATA FROM CSV INTO TABLE
            string[] vstup = null;
            int index = 0;
            int Id = 0;
            string FirstName = null;
            string LastName = null;
            int Age = 0;
            string Email = null;
            string Address = null;
            int Phone = 0;
            string Job = null;


            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();

            /*string dotaz2 = "SET IDENTITY_INSERT Osoby ON; " +
                 "INSERT INTO Osoby (Id, FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@Id, @FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)" +
                 "SET IDENTITY_INSERT Osoby OFF; ";*/
            //string dotaz2 = "INSERT INTO Osoby (Id, FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@Id, @FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)";
            string dotaz = "INSERT INTO Osoby (FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)";


            foreach (string radka in dataList)
            {


                if (index >= 1)
                {
                    vstup = radka.Split('\t');
                    Id = int.Parse(vstup[0]);
                    FirstName = vstup[1];
                    LastName = vstup[2];
                    Age = int.Parse(vstup[3]);
                    Email = vstup[4];
                    Address = vstup[5];
                    Phone = int.Parse(vstup[6]);
                    Job = vstup[7];

                    //MessageBox.Show(vstup[7]);
                    SqlCommand prikaz = new SqlCommand(dotaz, spojeni);

                    //prikaz2.Parameters.AddWithValue("@Id", Id);
                    prikaz.Parameters.AddWithValue("@FirstName", FirstName);
                    prikaz.Parameters.AddWithValue("@LastName", LastName);
                    prikaz.Parameters.AddWithValue("@Age", Age);
                    prikaz.Parameters.AddWithValue("@Email", Email);
                    prikaz.Parameters.AddWithValue("@Address", Address);
                    prikaz.Parameters.AddWithValue("@Phone", Phone);
                    prikaz.Parameters.AddWithValue("@Job", Job);

                    prikaz.ExecuteNonQuery();
                }
              

                index++;
            }

            spojeni.Close();
        }



        //INSERT
        //InsertDataIntoTable
        void InsertDataIntoTable()
        {
            string[] vstup = null;
            int index = 0;
            int Id = 0;
            string FirstName = null;
            string LastName = null;
            int Age = 0;
            string Email = null;
            string Address = null;
            int Phone = 0;
            string Job = null;


            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();

            /* string dotaz2 = "SET IDENTITY_INSERT Osoby ON; " +
                  "INSERT INTO Osoby (Id, FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@Id, @FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)" +
                  "SET IDENTITY_INSERT Osoby OFF; ";*/
            //string dotaz2 = "INSERT INTO Osoby (Id, FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@Id, @FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)";
            string dotaz = "INSERT INTO Osoby (FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)";

            SqlCommand prikaz = new SqlCommand(dotaz, spojeni);

            Id = 0;
            FirstName = textBoxFIRSTNAME.Text;
            LastName = textBoxLASTNAME.Text;
            int.TryParse(textBoxLASTNAME.Text, out Age);
            Email = textBoxEMAIL.Text;
            Address = textBoxADDRESS.Text;
            int.TryParse(textBoxPHONE.Text, out Phone);
            Job = textBoxJOB.Text;


            //prikaz2.Parameters.AddWithValue("@Id", Id);
            prikaz.Parameters.AddWithValue("@FirstName", FirstName);
            prikaz.Parameters.AddWithValue("@LastName", LastName);
            prikaz.Parameters.AddWithValue("@Age", Age);
            prikaz.Parameters.AddWithValue("@Email", Email);
            prikaz.Parameters.AddWithValue("@Address", Address);
            prikaz.Parameters.AddWithValue("@Phone", Phone);
            prikaz.Parameters.AddWithValue("@Job", Job);

            prikaz.ExecuteNonQuery();

            spojeni.Close();

            LoadDatabase();


        }


        //UPDATE
        //UpdateDataInTable
        void UpdateDataInTable()
        {

            int Id = 0;
            string FirstName = null;
            string LastName = null;
            int Age = 0;
            string Email = null;
            string Address = null;
            int Phone = 0;
            string Job = null;

            string dotaz = "UPDATE Osoby SET FirstName=@FirstName, LastName=@LastName, Age=@Age, Email=@Email, Address=@Address, Phone=@Phone, Job=@Job WHERE Id=@Id";


            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();
            SqlCommand prikaz = new SqlCommand(dotaz, spojeni);

            int.TryParse(textBoxID.Text, out Id);
            FirstName = textBoxFIRSTNAME.Text;
            LastName = textBoxLASTNAME.Text;
            int.TryParse(textBoxAGE.Text, out Age);
            Email = textBoxEMAIL.Text;
            Address = textBoxADDRESS.Text;
            int.TryParse(textBoxPHONE.Text, out Phone);
            Job = textBoxJOB.Text;


            prikaz.Parameters.AddWithValue("@Id", Id);
            prikaz.Parameters.AddWithValue("@FirstName", FirstName);
            prikaz.Parameters.AddWithValue("@LastName", LastName);
            prikaz.Parameters.AddWithValue("@Age", Age);
            prikaz.Parameters.AddWithValue("@Email", Email);
            prikaz.Parameters.AddWithValue("@Address", Address);
            prikaz.Parameters.AddWithValue("@Phone", Phone);
            prikaz.Parameters.AddWithValue("@Job", Job);

            prikaz.ExecuteNonQuery();


            spojeni.Close();
            LoadDatabase();

        }



        //DELETE
        //DeleteDataInTable
        void DeleteDataInTableByID()
        {
            int Id = 0;
            string dotaz = "DELETE FROM osoby WHERE ID=@ID";
            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();
            SqlCommand prikaz = new SqlCommand(dotaz, spojeni);
            int.TryParse(textBoxID.Text, out Id);
            prikaz.Parameters.AddWithValue("@Id", Id);
            prikaz.ExecuteNonQuery();
            spojeni.Close();
            LoadDatabase();
        }

        void DeleteLoadedContent()
        {
            //listBox1.Items.Clear();
            dataList.Clear();
            dataGridView1.DataSource = null;
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Clear();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            //Delete loaded Content
            DeleteLoadedContent();
        }
    }
}
